<template lang="pug">
    v-card
        v-card-title Drawing and Sample Numbers
        v-card-text
            v-autocomplete(
                label="Photo Numbers"
                v-model="photoNumbers"
                :items="photos"
                :search-input.sync="searchPhoto"
                chips
                deletable-chips
                cache-items
                multiple
            )
            v-autocomplete(
                label="Plan Numbers"
                v-model="planNumbers"
                :search-input.sync="searchPlan"
                :items="plans"
                chips
                deletable-chips
                cache-items
                multiple
            )
            v-autocomplete(
                v-if="sectionAllowed"
                label="Section Numbers"
                v-model="sectionNumbers"
                :search-input.sync="searchSection"
                :items="sections"
                chips
                multiple
            )
            div(v-if="sampleAllowed")
                hr
                v-autocomplete(
                    label="Sample Numbers"
                    v-model="sampleNumbers"
                    :search-input.sync="searchSample"
                    :items="samples"
                    chips
                    deletable-chips
                    cache-items
                    multiple
                )
</template>

<script>
import { debounce } from "debounce";
import { mapActions, mapGetters } from "vuex";
export default {
    name: "drawings_and_samples",
    props: {
        plans: {
            required: true,
            type: Array
        },
        sections: {
            required: false,
            type: Array,
            default() {
                return [];
            }
        },
        samples: {
            required: false,
            type: Array,
            default() {
                return [];
            }
        },
        sectionAllowed: {
            required: false,
            type: Boolean,
            default: false
        },
        sampleAllowed: {
            required: false,
            type: Boolean,
            default: false
        },
        photos: {
            required: true,
            type: Array
        }
    },
    data: function() {
        return {
            planNumbers: [],
            sectionNumbers: [],
            sampleNumbers: [],
            photoNumbers: [],
            searchPhoto: "",
            searchSection: "",
            searchPlan: "",
            searchSample: ""
        };
    },
    watch: {
        planNumbers: function() {
            this.emitChange();
        },
        sectionNumbers: function() {
            this.emitChange();
        },
        sampleNumbers: function() {
            this.emitChange();
        },
        photoNumbers: function() {
            this.emitChange();
        },
        searchPhoto: debounce(function() {
            if (!this.searchPhoto || this.searchPhoto.trim() === "") {
                return [];
            }
            this.fetchAllSearch({
                url: this.getATrench.data.relationships.photos.links.related,
                options: {
                    params: {
                        like: this.searchPhoto
                    }
                }
            }).then(response => {
                if (!response.data) {
                    return [];
                }
                this.photoNumbers = response.data.map(el => {
                    return {
                        text: el.attributes.number.toString(),
                        value: el.id
                    };
                });
            });
        }, 500),
        searchSection: debounce(function() {
            if (!this.searchSection || this.searchSection.trim() === "") {
                return [];
            }
            this.fetchAllSearch({
                url: this.getATrench.data.relationships.sections.links.related,
                options: {
                    params: {
                        likenumber: this.searchSection
                    }
                }
            }).then(response => {
                if (!response.data) {
                    return [];
                }
                this.sectionNumbers = response.data.map(el => {
                    return {
                        text: el.attributes.number.toString(),
                        value: el.id
                    };
                });
            });
        }, 500),
        searchPlan: debounce(function() {
            if (!this.searchPlan || this.searchPlan.trim() === "") {
                return [];
            }
            this.fetchAllSearch({
                url: this.getATrench.data.relationships.contexts.links.related,
                options: {
                    params: {
                        likenumber: this.searchPlan
                    }
                }
            }).then(response => {
                if (!response.data) {
                    return [];
                }
                this.planNumbers = response.data.map(el => {
                    return {
                        text: el.attributes.number.toString(),
                        value: el.id
                    };
                });
            });
        }, 500),
        searchSample: debounce(function() {
            if (!this.searchSample || this.searchSample.trim() === "") {
                return [];
            }
            this.fetchAllSearch({
                url: this.getATrench.data.relationships.contexts.links.related,
                options: {
                    params: {
                        likenumber: this.searchSample
                    }
                }
            }).then(response => {
                if (!response.data) {
                    return [];
                }
                this.sampleNumbers = response.data.map(el => {
                    return {
                        text: el.attributes.number.toString(),
                        value: el.id
                    };
                });
            });
        }, 500)
    },
    computed: {
        ...mapGetters({
            getATrench: "trench/getATrench"
        })
    },
    methods: {
        ...mapActions({
            fetchAllSearch: "search/fetchAllSearch"
        }),
        remove: function(array, item) {
            const index = this[array].indexOf(item.text);
            if (index >= 0) {
                this[array].splice(index, 1);
            }
        },
        emitChange: function() {
            const dataEmit = {
                context: "drawingsSamplesPhotos",
                data: {
                    planNumbers: this.planNumbers,
                    sectionNumbers: this.sectionNumbers,
                    sampleNumbers: this.sampleNumbers,
                    photoNumbers: this.photoNumbers
                }
            };
            this.$emit("input", dataEmit);
        }
    }
};
</script>
